
IR.AddListener(IR.EVENT_START, 0,  function () {

IR.ShowPopup("Widget")
    var HUE = {};


    HUE.SetupInterface = function () {

        HUE.HUE_GUI.Connect_status.GetState(0).Text = "Connecting...";
        HUE.HUE_GUI.EnterIP_field.GetState(0).TextAlign = 5;
        HUE.HUE_GUI.EnterIP_error.GetState(0).TextColor = 255 << 24 | 0 << 16 | 0 << 8 | 0xFF;

        if (HUE.BridgeId) {
            HUE.HUE_GUI.cloud.Visible = true;
            HUE.HUE_GUI.cloud_1.Visible = true;
            HUE.HUE_GUI.Settings_cloud.Visible = true;
            HUE.HUE_GUI.Settings_cloud_1.Visible = true;
        } else {
            HUE.HUE_GUI.cloud.Visible = false;
            HUE.HUE_GUI.cloud_1.Visible = false;
            HUE.HUE_GUI.Settings_cloud.Visible = false;
            HUE.HUE_GUI.Settings_cloud_1.Visible = false;
        }

        HUE.HUE_GUI.page.GetItem("switch").GetState(0).BorderColor = 0 << 24 | 0 << 16 | 0 << 8 | 0xFF;
        HUE.HUE_GUI.page.GetItem("switch").GetState(1).BorderColor = 0 << 24 | 0 << 16 | 0 << 8 | 0xFF;
        HUE.HUE_GUI.page.GetItem("switch").GetState(0).Border = 14;
        HUE.HUE_GUI.page.GetItem("switch").GetState(1).Border = 14;
        HUE.HUE_GUI.Widget_swit.GetState(0).Border = 14;
        HUE.HUE_GUI.Widget_swit.GetState(1).Border = 14;
        HUE.HUE_GUI.Widget_swit.GetState(0).BorderColor = 0 << 24 | 0 << 16 | 0 << 8 | 0xFF;
        HUE.HUE_GUI.Widget_swit.GetState(1).BorderColor = 0 << 24 | 0 << 16 | 0 << 8 | 0xFF;

        HUE.HUE_GUI.page.GetItem("switch").GetState(0).TextColor = 0 << 24 | 0 << 16 | 0 << 8 | 0xFF;
        HUE.HUE_GUI.page.GetItem("switch").GetState(1).TextColor = 0 << 24 | 122 << 16 | 255 << 8 | 0xFF;
        HUE.HUE_GUI.Widget_swit.GetState(0).TextColor = 0 << 24 | 0 << 16 | 0 << 8 | 0xFF;
        HUE.HUE_GUI.Widget_swit.GetState(1).TextColor = 0 << 24 | 122 << 16 | 255 << 8 | 0xFF;


        HUE.HUE_GUI.bri.Max = 254;
        HUE.HUE_GUI.red_slider.Max = 254;
        HUE.HUE_GUI.green_slider.Max = 254;
        HUE.HUE_GUI.blue_slider.Max = 254;

        HUE.HUE_GUI.bri.Height = 12;
        HUE.HUE_GUI.red_slider.Height = 12;
        HUE.HUE_GUI.green_slider.Height = 12;
        HUE.HUE_GUI.blue_slider.Height = 12;
    };


    HUE.makeDataArray = function () {
        if (null == HUE.HueUserID || undefined == HUE.HueUserID)
            HUE.HueUserID = 'nouser';
        return [",/api", // 0 - start the request
            "\r\n\r\n", // 1 - end the request
            ",/api/" + HUE.HueUserID + "/lights/", // 2 - lights request
            ",/api/" + HUE.HueUserID + "/groups/", // 3 - grous request
            ",/api/" + HUE.HueUserID + "/schedules/", // 4 - schedules request
            ",/api/" + HUE.HueUserID + "/config/" // 5 - config request
        ];
    };

    /*HUE.makeWidget = function (numb, name, Lamp) { //  добавление виджета для каждой лампы

        if ( HUE.module.GetPopup("Widget" + numb ) == null)
            var popup = HUE.module.ClonePopup(HUE.module.GetPopup("Widget"), "Widget" + numb);
        else
            var popup = HUE.module.GetPopup("Widget" + numb);

        IR.Log("~~~~~~~~~~~~~ popup.Name " + popup.Name);
        popup.GetItem("Light_text").Text = name;
        var widget = Lamp.addWidget(popup);
    };*/

    HUE.DataReflection = function (lightArray) {
        for (var i = 0; i < lightArray.length; i++) {
            HUE.hueMainDev.SetFeedback("Brightness" + (i + 1), Math.round(lightArray[i].bri * 100 / 255));
            HUE.hueMainDev.SetFeedback("Switch" + (i + 1), lightArray[i].swit);

        }
    }


    HUE.netDevice = IR.GetCurrentLocalIPInfo();
    //HUE.moduleID = mID;
    //HUE.BusID = bID;
    //HUE.module = B.getModule(mID);
    HUE.HueUserID = undefined;
    HUE.Host_IP = undefined;
    HUE.BridgeId = undefined;
    HUE.settings = {};// = HUE.module.getSubDevice("Hue_Settings");
    HUE.settings.getData = {
      "UserID": HUE.HueUserID,
      "HueIP": HUE.Host_IP,
      "BridgeID": HUE.BridgeId
    };
    HUE.settings_data = HUE.settings.getData;
    HUE.currentPopup = '';
    HUE.Test_ip = /^(25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[0-9]{2}|[0-9])(\.(25[0-5]|2[0-4][0-9]|[0-1][0-9]{2}|[0-9]{2}|[0-9])){3}$/;
    HUE.HUE_GUI = Hue_Gui(HUE);


    HUE.hueMainDev = IR.GetDevice("Hue");
    HUE.Hue_connection = IR.GetVariable("Global.HueConnection");
    HUE.accessToken = IR.GetVariable("Global.AccessToken");

    var CurrentHub = undefined;


    if (HUE.settings_data && HUE.settings_data.HueIP && HUE.settings_data.BridgeID) {
        HUE.Host_IP = HUE.settings_data.HueIP;
        HUE.BridgeId = HUE.settings_data.BridgeID;
    }


    HUE.SetupInterface();
    HUE.hueMainDev.AddTag("Brightness", "01, 00, 00, 00, 00, 00, 00, 00, 00");
    HUE.hueMainDev.AddTag("Switch", "01, 00, 00, 00, 00, 00, 00, 00, 00");
    /*var length = HUE.module.SubDevices.length;
    for (var i = 0, idx =  1; i < length; i++) {
        var name = HUE.module.SubDevices[i].Device;
        if (name.indexOf("Light") >= 0) { // подустройства лампочки
            var lamp = HUE.module.getSubDevice(HUE.module.SubDevices[i].Device);

            HUE.makeWidget(idx - 1, "HUE Light " + idx, lamp); // восстановление прежних виджетов
            if (IR.GetItem("Widget" + (idx - 1) + HUE.moduleID) != null)
                HUE.HUE_GUI["Widget_" + idx] = IR.GetItem("Widget" + (idx - 1) + HUE.moduleID);

            // востановление Events и Conditions
            var lampData = lamp.getData();
            if (!lampData || !lampData.lightID)
                continue;

            

            idx++;
        }
    }*/


    function HueHub(ip, id) { // объект для хаба

        this.hostIP = ip || '';
        this.bridgeId = id || '';
        this.hueWorker = undefined;

        var self = this;

        this.Start_Hue_connection = function () {
            HUE.accessToken = IR.GetVariable("Global.AccessToken");
            IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  this.accessToken " +  HUE.accessToken);


            if (HUE.Hue_connection == undefined || HUE.Hue_connection == null) {
                HUE.Hue_connection = 0;
            }


            HUE.HUE_GUI.local_cloud.Value = HUE.Hue_connection;
            HUE.HUE_GUI.cloud_1.Value = HUE.Hue_connection;
            HUE.HUE_GUI.Settings_cloud_1.Value = HUE.Hue_connection;

            if (HUE.Hue_connection == 0) // local connection
            {
                HUE.HUE_GUI.Connect_status.GetState(0).Text = "Connecting...";
                IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ local connection");
                if (self.hueWorker != undefined && self.hueWorker != null)
                    self.hueWorker.makeFree();
                self.hueWorker = new HUE_local(HUE);
            }
            if (HUE.Hue_connection == 1) // cloud connection
            {
                function OpenBrowser(BridgeId) {

                    IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Remote connection OpenBrowser");
                    IR.OpenBrowser("https://www.meethue.com/en-us/api/gettoken?appid=hueapp&devicename=iPhone+5&deviceid=" + BridgeId);
                    IR.AddListener(IR.EVENT_BROWSER_GET_DATA, 0, getData = function (url, data) {

                        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~  EVENT_BROWSER_GET_DATA " + data);

                        var idx = data.indexOf("/login/");
                        if (idx == 0) {
                            var code = data.substr(7);

                            if(!code){
                                HUE.Hue_connection = 0;
                                IR.CloseBrowser();
                                IR.RemoveListener(IR.EVENT_BROWSER_GET_DATA, 0, getData);
                                return;
                            }
                            IR.Log("Authorization code=" + code);
                            HUE.accessToken = code;
                            IR.SetVariable("Global.AccessToken",  HUE.accessToken);
                            IR.CloseBrowser();
                            IR.RemoveListener(IR.EVENT_BROWSER_GET_DATA, 0, getData);
                            HUE.HUE_GUI.Connect_status.GetState(0).Text = "Connecting...";
                            if (self.hueWorker != undefined && self.hueWorker != null)
                                self.hueWorker.makeFree();
                            self.hueWorker = new HUE_cloud(HUE);

                        }
                    });

                }

                if ( HUE.accessToken == undefined || HUE.accessToken == "") {
                    OpenBrowser(self.bridgeId);
                } else {
                    IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Remote connection уже с токеном");
                    HUE.HUE_GUI.Connect_status.GetState(0).Text = "Connecting...";
                    if (self.hueWorker != undefined && self.hueWorker != null)
                        self.hueWorker.makeFree();
                    self.hueWorker = new HUE_cloud(HUE);

                }

            }
            if (HUE.Hue_connection == 2) //server connection
            {
                HUE.HUE_GUI.Connect_status.GetState(0).Text = "Connecting...";
                IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ server connection");
                if (self.hueWorker != undefined && self.hueWorker != null)
                    self.hueWorker.makeFree();
                self.hueWorker = new HUE_server(HUE);
            }

        }
    }

    HUE.createHub = function (in_ip, in_id) {
        HUE.Host_IP = in_ip;
        HUE.BridgeId = in_id;
        CurrentHub = new HueHub(in_ip, in_id);
        CurrentHub.Start_Hue_connection();
    }

    HUE.connectionFlow = function () { // получение доступа к хабу

        if (2 == HUE.Hue_connection)
            HUE.Hue_connection = 0;
        if (1 == HUE.Hue_connection && !HUE.accessToken)
            HUE.Hue_connection = 0;

        var HueBroker = IR.CreateDevice(IR.DEVICE_CUSTOM_HTTP_TCP, "HueApi", "www.meethue.com", 443, "", "", true); // драйвер чтобы получить ip и id моста

        if (undefined != HUE.Host_IP && undefined != HUE.BridgeId) {
            CurrentHub = new HueHub(HUE.Host_IP, HUE.BridgeId);
            CurrentHub.Start_Hue_connection();
        } else {
            HueBroker.Connect();
            HueBroker.SendEx({
                Type: "GET",
                Url: "/api/nupnp",
                cbReceiveText: function (text, code, headers) {
                }
            });

            IR.AddListener(IR.EVENT_ERROR, HueBroker, error_HueBroker = function (ID, LocalIP, LocalPort, HostIP, HostPort, ErrorCode) // когда не удалось подключиться к "брокеру" запускаем ручной ввод IP
            {
                IR.Log("~~~~~~~~~~~~~~~~~~~~~EVENT_ERROR");
                HUE.currentPopup = HUE.HUE_GUI.EnterIP.Name;
                HUE.HUE_GUI.Connect_status.GetState(0).Text = "Enter IP manually";
                HueBroker.Disconnect();

            });

            IR.AddListener(IR.EVENT_RECEIVE_TEXT, HueBroker, Cloud_HueBroker_receive = function (text) {

                IR.Log("Получение ip и id через брокер : " + text);

                text = JSON.Parse(text);
                if (text[0]) {
                    HUE.BridgeId = text[0].id || '';
                    HUE.Host_IP = text[0].internalipaddress || '';
                }
                if (HUE.Test_ip.test(HUE.Host_IP) != true || text.length > 1) {
                    IR.Log("~~~~~~~~~~~~~~~~~~~~~ ShowPopup EnterIP");
                    IR.RemoveListener(IR.EVENT_RECEIVE_TEXT, HueBroker, Cloud_HueBroker_receive);
                    IR.RemoveListener(IR.EVENT_ERROR, HueBroker, error_HueBroker);
                    HUE.currentPopup = HUE.HUE_GUI.EnterIP.Name;
                    HUE.HUE_GUI.Connect_status.GetState(0).Text = "Enter IP manually";

                    /*
                     IR.SetTimeout(5000,function(){                    // пока просто повтор попытки

                     HueBroker.SendEx({
                     Type: "GET",
                     Url: "/api/nupnp",
                     cbReceiveText: function(text, code, headers){ }

                     });

                     });
                     */
                } else {
                    IR.RemoveListener(IR.EVENT_RECEIVE_TEXT, HueBroker, Cloud_HueBroker_receive);
                    IR.RemoveListener(IR.EVENT_ERROR, HueBroker, error_HueBroker);

                    CurrentHub = new HueHub(HUE.Host_IP, HUE.BridgeId);
                    CurrentHub.Start_Hue_connection();
                }

            });
        }

    };

    ///////////////////////////////////////////////////////////////////
    // Обработка событий ч.1
    ///////////////////////////////////////////////////////////////////


    // start - раскомментировать когда появится сервер
    /*
     B.AddListener(B.EVENT_CONNECT_TO_SERVER_AVAILABLE, 0, online = function () {

     IR.HidePopup(HUE.HUE_GUI.EnterIP.Name);

     if (null == HUE.settings_data || undefined == HUE.settings_data.UserID || null == HUE.settings_data.UserID) {
     IR.Log("~~~~~~~~~~~~~~~~~~~~~ Сначала собрать данные через локал дев: ");
     HUE.SetupInterface();
     HUE.connectionFlow();
     return;
     }

     HUE.Hue_connection = 2;

     IR.Log("~~~~~~~~~~~~~~~~~~~~~ Hue_connection was Changed: from any to server");
     if (undefined != CurrentHub && undefined != CurrentHub.hueWorker) {
     CurrentHub.hueWorker.makeFree();
     }
     CurrentHub = new HueHub();
     CurrentHub.Start_Hue_connection();
     });

     B.AddListener(B.EVENT_CONNECT_TO_SERVER_NOT_AVAILABLE, 0, offline = function () {

     IR.Log("~~~~~~~~~~~~~~~~~~~~~ Hue_connection was Changed: from server to any ");
     if (undefined != CurrentHub && undefined != CurrentHub.hueWorker) {
     CurrentHub.hueWorker.makeFree();
     }
     CurrentHub = new HueHub();
     HUE.SetupInterface();
     HUE.connectionFlow();

     });
     */
    // end - раскомментировать когда появится сервер

    // start  - убрать когда появится сервер
    if (undefined != CurrentHub && undefined != CurrentHub.hueWorker) {
        CurrentHub.hueWorker.makeFree();
    }
    HUE.connectionFlow();
    // end  - убрать когда появится сервер

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.local_cloud_done, function () {

        if(  (HUE.Hue_connection == 0 && HUE.Hue_connection == HUE.HUE_GUI.local_cloud.Value) || (HUE.Hue_connection == 1 && !HUE.accessToken) )
            return;
        HUE.Hue_connection = HUE.HUE_GUI.local_cloud.Value;
        if (HUE.HUE_GUI.local_cloud.Value == 0) {
            IR.Log("~~~~~~~~~~~~~~~~~~~~~ Hue_connection was Changed: from remote to local");
            if (CurrentHub != undefined)
                CurrentHub.Start_Hue_connection();
        } else if (HUE.HUE_GUI.local_cloud.Value == 1) {
            IR.Log("~~~~~~~~~~~~~~~~~~~~~ Hue_connection was Changed: from local to remote");
            if (CurrentHub != undefined)
                CurrentHub.Start_Hue_connection();
        }

    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.EnterIP_ok, function () {
        HUE.HUE_GUI.EnterIP_error.GetState(0).Text = '';
        HUE.Host_IP = HUE.HUE_GUI.EnterIP_field.Text.replace(/\s+/g, '');
        if (HUE.Test_ip.test(HUE.Host_IP) == true) {
            GetIDbyIP(HUE);
        } else {
            HUE.HUE_GUI.EnterIP_error.GetState(0).Text = "Error ip format";
        }
         IR.ShowKeyboard(0);
    });   
	 IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.EnterIP_field, function () {
       IR.ShowKeyboard(2);
    });   	
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("Widget"), function () {
        if ('' != HUE.currentPopup)
            IR.ShowPopup(HUE.currentPopup);
    });


    IR.AddListener(IR.EVENT_ITEM_SHOW, HUE.HUE_GUI.hue_cloud, function () // обновить значение треггер-кнопки
    {
        HUE.HUE_GUI.local_cloud.Value = (  1 != HUE.Hue_connection ? 0 : 1);
    });

    IR.AddListener(IR.EVENT_ITEM_SHOW, HUE.HUE_GUI.EnterIP_show, function () // обновить значение ip_field
    {
        HUE_GUI.EnterIP_field.Text = ( HUE.Host_IP == undefined ? "0.0.0.0" : HUE.Host_IP);
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.hue_cloud.GetItem("Back"), function () {
        HUE.HUE_GUI.local_cloud.Value = HUE.HUE_GUI.local_cloud.Value = HUE.Hue_connection;
        HUE.HUE_GUI.cloud_1.Value = HUE.Hue_connection;
        HUE.HUE_GUI.Settings_cloud_1.Value = HUE.Hue_connection;
    });

});


