
/*function HUE_server() {

	Hue_connection = GetVariable("Global.Hue_connection");
	if (Hue_connection != 2)
		return;
	IR.Log("HUE is online : " + Hue_connection);

	HUE_GUI.Settings_cloud.Visible = false;
	HUE_GUI.Settings_cloud_1.Visible = false;
	HUE_GUI.cloud.Visible = false;
	HUE_GUI.cloud_1.Visible = false;

	var server_dev = IR.GetDevice("iRidium Server");
	if (settings_data && settings_data.UserID) {
		HueUserID = settings_data.UserID;
		IR.Log("~~~~~~~~~~~~~~~~~~	this.hueUserID : " + HueUserID);
		var data = makeDataArray();
	}
	var stateFromServer = "";
	this.makeFree = function () {
		IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ makeFree: server");
		ServerDestruction();
	}

	var length = module.SubDevices.length;
	for (var i = 0; i < length; i++) {
		var name = module.SubDevices[i].Device;
		if (name.indexOf("Light") >= 0) { // подустройства лампочки
			var lamp = module.getSubDevice(module.SubDevices[i].Device);
			lampData = lamp.getData();
			if (!lampData || !lampData.lightID)
				continue;

			lamp.updateAction("HUE Light " + lampData.lightID + " Off ", {
				Method : lightOff,
				Space : {
					lightID : lampData.lightID
				}
			});
			lamp.updateAction("HUE Light " + lampData.lightID + " On ", {
				Method : lightOn,
				Space : {
					lightID : lampData.lightID
				}
			});

			lamp.updateAction("Set brightness HUE Light " + lampData.lightID, {
				Method : lightBri,
				Space : {
					lightID : lampData.lightID
				}
			});
         
         lamp.updateAction("Set color HUE Light " + lampData.lightID, {
				Method : lightSetColor,
				Space : {
					lightID : lampData.lightID
				}
			});
		}
	}

	IR.AddListener(IR.EVENT_TAG_CHANGE, server_dev, server_tags_listener = function (name, value) {

		switch (name) {

		case "HueState" + HUE.ModuleID:

			stateFromServer = value;
			analize();
			break;
		}
	});

	light_current = 1; // The current light

	var color = 0; // The color from Picker in number space
	var red = 0; // The Red color in RGB space
	var green = 0; // The Green color in RGB space
	var blue = 0; // The Blue color in RGB space

	var light_array = []; // Parameters of lights Array
	var reloadLightList = false;
	this.isCanUpdadeInerface = true;
	this.isCanUpdadeBri = true;
	var timerInerfaceBlock;
	var listener_test = 0;
	var self = this;
	////////////////////////////////////////////////////////////////////////////////
	// 		The Parser
	////////////////////////////////////////////////////////////////////////////////


	function analize() {

		if (!isJson(stateFromServer))
			return;

		t = JSON.Parse(stateFromServer);
		IR.Log("~~~~~ analyze server " + stateFromServer);
		var id = []; // Array of indexes is declared
		if (!(t instanceof Array)) // If type of JSON isn't array then it is transformed to array
			t = [t];

		for (var x in t[0]) { // Zero item from array of JSON is indexed
			if( t[0].hasOwnProperty(x) )  
			id.push(x);
		}

		switch (id[0]) {
		case "success": // Zero index is message of success

			self.isCanUpdadeInerface = true;
			var id_2;

			for (var i = 0; i < t.length; i++) {

				for (var x in t[i].success) // Lights section is indexed
					id_2 = x;

				var nummber = id_2.split("/");
				switch (id_2.charAt(id_2.length - 2) + id_2.charAt(id_2.length - 1)) {
				case "ri":
					light_array[nummber[2] - 1].bri = t[i].success[id_2];
					break;
				case "on":
					light_array[nummber[2] - 1].swit = t[i].success[id_2];
					break;

				case "ue":
					light_array[nummber[2] - 1].hue = t[i].success[id_2];
					break;

				case "at":
					light_array[nummber[2] - 1].sat = t[i].success[id_2];
					break;
				}
			}
			DataReflection(light_array);
			ColorLoader(); // Draw data


			break;
		case "1": // Lights section
			id = []; // Clear the Array of index
			for (var x in t[0]) { // Success section is indexed
			if( t[0].hasOwnProperty(x) )  
				id.push(x);
			}
			HUE_GUI.Connect_status.GetState(0).Text = "Server connected";
			for (var i = 0; i < id.length; i++) {

				var light = t[0][id[i]];

				if (undefined == light_array[i]) {
					reloadLightList = true;
					var popup = IR.GetItem("Widget" + i + HUE.ModuleID)
						if (popup == null)
						continue;

						light_array[i] = new Object();
					widgetsButtonsSetEvents(popup, i + 1);
					IR.Log("~~~~~ new light_array " + light_array.length);
					setLightNumber(light_current);
				}

				light_array[i].swit = light.state.on;
				light_array[i].name = light.name;
				light_array[i].bri = light.state.bri;
				light_array[i].hue = light.state.hue;
				light_array[i].sat = light.state.sat;
			}
			DataReflection(light_array);
			if (reloadLightList) {
				reloadLightList = false;
			}

			if (self.isCanUpdadeInerface);
			ColorLoader(); // Draw data

			break;
		case "error":

			switch (t[0].error.type) {
			case 1: // unauthorized user
			case 101:
				HUE_GUI.Connect_status.GetState(0).Text = t[0].error.description;
				break;

			default:
				HUE_GUI.Connect_status.GetState(0).Text = t[0].error.description;

				break;
			}
			break;

			// TODO для групп, таймеров и пользователей t[0].schedules[i.toString()]["name"], t[0].groups[i.toString()]["name"], t[0].config.whitelist надо индексировать

		}

	}

	////////////////////////////////////////////////////////////////////////////////
	//		 Functions
	////////////////////////////////////////////////////////////////////////////////


	function ColorLoader() { // измеенние интерфейса
		if (!self.isCanUpdadeInerface) {
			return;
		}

		var createItem = function (i) {
			return;
		}

		for (var i = 0; i < light_array.length; i++) {
			createItem(i);
			var color_load = HSVtoRGB(light_array[i].hue / 65535, light_array[i].sat / 255, 1);
			red = color_load[0];
			green = color_load[1];
			blue = color_load[2];

			var vidget = "Widget_" + (i + 1);
			IR.Log("vidget " + vidget + "   is: " + HUE_GUI[vidget]);
			if (HUE_GUI[vidget]) {
				var color_load_2 = red << 24 | green << 16 | blue << 8 | 0xFF;
				HUE_GUI[vidget].GetItem("switch").Value = light_array[i].swit;
				HUE_GUI[vidget].GetItem("switch").GetState(1).FillColor = color_load_2;
			}
		}

		HUE_GUI.swit.Value = light_array[light_current - 1].swit;
		if (self.isCanUpdadeBri) {
			HUE_GUI.bri.Value = light_array[light_current - 1].bri;
			HUE_GUI.page.GetItem("bri_percent").Text = Math.round(light_array[light_current - 1].bri * 100 / 254) + "%";
		}

		var color_load = HSVtoRGB(light_array[light_current - 1].hue / 65535, light_array[light_current - 1].sat / 255, 1);
		red = color_load[0];
		green = color_load[1];
		blue = color_load[2];

		HUE_GUI.red_slider.Value = red;
		HUE_GUI.green_slider.Value = green;
		HUE_GUI.blue_slider.Value = blue;

		var color_load_2 = red << 24 | green << 16 | blue << 8 | 0xFF;
		HUE_GUI.color_detector.GetState(0).FillColor = color_load_2;
		HUE_GUI.page.GetItem("switch").GetState(1).FillColor = color_load_2;

	}

	function setLightNumber(n) { // set light and visible current in the list

		light_current = n;
		ColorLoader();
	}

	function set_switch_sat_bri_hue() { // Setting the propery of the light
		var hsv_color = rgb_to_hsv(red, green, blue);
		setlight(HUE_GUI.swit.Value ? true : false, hsv_color[1], HUE_GUI.bri.Value, hsv_color[0]);

	}

	function setSwitch_widget_button() { // Switcher
		setSwitch(HUE_GUI.Widget_swit.Value ? true : false);
	}

	function setSwitch_button() { // Switcher
		setSwitch(HUE_GUI.swit.Value ? true : false);
	}

	function setNewColor() { // Set Color via Picker
		color = HUE_GUI.color.PickColor;
		red = (color >> 24) & 0xFF;
		green = (color >> 16) & 0xFF;
		blue = (color >> 8) & 0xFF;

		set_switch_sat_bri_hue();
	}

	function setlight(on, sat, bri, hue, xy, ct, alert, effect, transitiontime) {
		self.isCanUpdadeInerface = false;

		bri = HUE_GUI.bri.Value;
		var color_load = HSVtoRGB(hue / 65535, sat / 255, 1);
		var rgb = color_load[0] << 24 | color_load[1] << 16 | color_load[2] << 8 | 0xFF;
		HUE_GUI.color_detector.GetState(0).FillColor = rgb;
		HUE_GUI.swit.GetState(1).FillColor = rgb;
		HUE_GUI["Widget_" + light_current].GetItem("switch").GetState(1).FillColor = rgb;

		light_array[light_current - 1].sat = sat;
		light_array[light_current - 1].bri = bri;
		light_array[light_current - 1].hue = hue;
		light_array[light_current - 1].swit = on;

		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + light_current + "/state," + "{\"on\":" + on + ",\"sat\":" + sat + ",\"bri\":" + bri + ",\"hue\":" + hue + "}");

	}

	function setSat(light_n, sat) { // change light property
		self.isCanUpdadeInerface = false;

		if (sat > 255)
			sat = 255;
		if (sat < 0)
			sat = 0;
		if (!light_n)
			light_n = light_current;

		light_array[light_current - 1].sat = sat;
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + light_n + "/state," + "{\"sat\":" + sat + "}");

	}

	function setBri(light_n, bri) { // change light property
		self.isCanUpdadeInerface = false;

		if (bri > 254)
			bri = 254;
		if (bri < 0)
			bri = 0;
		if (!light_n)
			light_n = light_current;
		light_array[light_current - 1].bri = bri;
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + light_n + "/state," + "{\"bri\":" + bri + "}");

	}

	function setHUE(light_n, hue_) { // change light property
		self.isCanUpdadeInerface = false;

		if (hue_ > 65535)
			hue_ = 65535;
		if (hue_ < 0)
			hue_ = 0;
		if (!light_n)
			light_n = light_current;
		light_array[light_current - 1].hue = hue_;
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + light_n + "/state," + "{\"hue\":" + hue_ + "}");

	}

	function setColor(n, color) { // change light property
		self.isCanUpdadeInerface = false;

		red = (color >> 24) & 0xFF;
		green = (color >> 16) & 0xFF;
		blue = (color >> 8) & 0xFF;

		var divider_color = rgb_to_hsv(red, green, blue);
		light_array[light_current - 1].sat = divider_color[2];
		light_array[light_current - 1].bri = divider_color[1];
		light_array[light_current - 1].hue = divider_color[0];

		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + n + "/state," + "{\"sat\":" + divider_color[2] + ",\"bri\":" + divider_color[1] + ",\"hue\":" + divider_color[0] + "}");
	}

	function setSwitch(on, light_n) { // switch the light
		self.isCanUpdadeInerface = false;

		if (!light_n)
			light_n = light_current;
		light_array[light_current - 1].swit = on;
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + light_n + "/state," + "{\"on\":" + (on ? true : false) + "}");

	}

	function lightOn() { // action method
		//Check();
		IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~server lightOn " + this.lightID);
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + this.lightID + "/state," + "{\"on\":" + true + "}");
	}
	function lightOff() { //action method
		//Check();
		IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~server lightOff " + this.lightID);
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + this.lightID + "/state," + "{\"on\":" + false + "}");
	}
	function lightBri(bri) { //action method
		//Check();
		IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~server lightBri " + this.lightID);
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + this.lightID + "/state," + "{\"bri\":" + bri + "}");
	}
      
   function lightSetColor(color) { //action method
	
		IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~server lightSetColor " + this.lightID);
		var divider_color = rgb_to_hsv(color.red,color.green, color.blue);   
		server_dev.Set("HueCommand" + HUE.ModuleID, "PUT" + data[2] + this.lightID + "/state," + "{\"sat\":" + divider_color[2] + ",\"hue\":" + divider_color[0] + "}");
   }

   
	function briDown(delta) {
		self.isCanUpdadeBri = false;
		if (briTimer != undefined || briTimer != null) {
			IR.ClearInterval(briTimer);
		}
		briTimer = IR.SetTimeout(5000, function () {
				self.isCanUpdadeBri = true;
			});
		HUE_GUI.bri.Value = Math.max(0, HUE_GUI.bri.Value - delta);
		HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE_GUI.bri.Value * 100 / 254) + "%";
		set_switch_sat_bri_hue();
	}
	function briUp(delta) {
		self.isCanUpdadeBri = false;
		if (briTimer != undefined || briTimer != null) {
			IR.ClearInterval(briTimer);
		}
		briTimer = IR.SetTimeout(5000, function () {
				self.isCanUpdadeBri = true;
			});
		HUE_GUI.bri.Value = Math.min(254, HUE_GUI.bri.Value + delta);
		HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE_GUI.bri.Value * 100 / 254) + "%";
		set_switch_sat_bri_hue();
	}
	function ServerDestruction() {

		IR.RemoveListener(IR.EVENT_TAG_CHANGE, server_dev, server_tags_listener);

		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.color, setNewColor_server);
		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.bri, set_switch_bri_server);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down);
		IR.RemoveListener(IR.EVENT_ITEM_HOLD, HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up_hold);
		IR.RemoveListener(IR.EVENT_ITEM_HOLD, HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down_hold);

		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.red_slider, set_switch_redslider_server);
		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.green_slider, set_switch_greenslider_server);
		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.blue_slider, set_switch_blueslider_server);
		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.swit, setSwitch_button_server);
		IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.Widget_swit, setSwitch_widget_button_server);

		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonCCB300"), HUE_PUB_Light_buttonCCB300);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonFF8000"), HUE_PUB_Light_buttonFF8000);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button804000"), HUE_PUB_Light_button804000);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonABC400"), HUE_PUB_Light_buttonABC400);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button808000"), HUE_PUB_Light_button808000);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonFF0080"), HUE_PUB_Light_buttonFF0080);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button00A600"), HUE_PUB_Light_button00A600);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button81FEC2"), HUE_PUB_Light_button81FEC2);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button400080"), HUE_PUB_Light_button400080);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button00FFFF"), HUE_PUB_Light_button00FFFF);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button8000FF"), HUE_PUB_Light_button8000FF);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonFF80FF"), HUE_PUB_Light_buttonFF80FF);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button0080FF"), HUE_PUB_Light_button0080FF);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button0000FF"), HUE_PUB_Light_button0000FF);
		IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button404080"), HUE_PUB_Light_button404080);
	};

	////////////////////////////////////////////////////////////////////////////////
	// Public functions
	////////////////////////////////////////////////////////////////////////////////


	PUB_changeLight = function (n__, sat__, bri__, hue__) {
		setlight(HUE_GUI.swit.Value ? true : false, sat__, HUE_GUI.bri.Value, hue__);

	}

	PUB_switch = function (n, on) {
		setSwitch(on, n);
	}

	////////////////////////////////////////////////////////////////////////////////
	// Subscribe to events       ....
	////////////////////////////////////////////////////////////////////////////////


	function widgetsButtonsSetEvents(popup, i) {

		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF8000"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_FF8000();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button804000"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_804000();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonCCB300"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_CCB300();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF0080"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_FF0080();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button81FEC2"), function () {
			light_current = this.light;
			IR.Log("blue driver local");
			HUE_PUB_Light_server_81FEC2();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button00A600"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_00A600();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button8000FF"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_8000FF();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF80FF"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_FF80FF();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button0080FF"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_0080FF();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button00FFFF"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_00FFFF();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button0000FF"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_0000FF();
		}, {
			light : i
		});
		IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button404080"), function () {
			light_current = this.light;
			HUE_PUB_Light_server_404080();
		}, {
			light : i
		});

		IR.AddListener(IR.EVENT_ITEM_RELEASE, popup.GetItem("switch"), function () {
			light_current = this.light;
			PUB_switch(light_current, Boolean(this.Switch.Value));
		}, {
			light : i,
			Switch : popup.GetItem("switch")
		});

		IR.AddListener(IR.EVENT_ITEM_RELEASE, popup.GetItem("Remote"), function () {
			light_current = this.light;
			HUE_GUI.page.GetItem("LightName").GetState(0).Text = light_array[light_current - 1].name;
			IR.ShowPopup(HUE_GUI.page.Name);
		}, {
			light : i
		});

	}

	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.color, setNewColor_server = function () {
		setNewColor();
	});
	
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down = function () {
		briDown(10);
	});

	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up = function () {
		briUp(10);
	});

	IR.AddListener(IR.EVENT_ITEM_HOLD, HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down_hold = function () {
		briDown(5);
	});

	IR.AddListener(IR.EVENT_ITEM_HOLD, HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up_hold = function () {
		briUp(5);
	});
	
	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.bri, set_switch_bri_server = function () {
		set_switch_sat_bri_hue();
		HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE_GUI.bri.Value * 100 / 254) + "%";
	});

	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.red_slider, set_switch_redslider_server = function () {
		red = HUE_GUI.red_slider.Value;
		set_switch_sat_bri_hue();
	});
	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.green_slider, set_switch_greenslider_server = function () {
		green = HUE_GUI.green_slider.Value;
		set_switch_sat_bri_hue();
	});
	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.blue_slider, set_switch_blueslider_server = function () {
		blue = HUE_GUI.blue_slider.Value;
		set_switch_sat_bri_hue();
	});

	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.swit, setSwitch_button_server = function () {
		setSwitch_button();
	});

	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.Widget_swit, setSwitch_widget_button_server = function () {
		setSwitch_widget_button();
	});

	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.hue_cloud.GetItem("Back"), function () {
		HUE_GUI.local_cloud.Value = foretest;
		HUE_GUI.cloud.Value = foretest;
		HUE_GUI.Settings_cloud.Value = foretest;

	});

	function HUE_PUB_All_on() {
		PUB_switch(light_current, true);
	}
	function HUE_PUB_Light_server_FF8000() {

		PUB_changeLight(light_current, 255, 255, 38837);
	}
	function HUE_PUB_Light_server_804000() {

		PUB_changeLight(light_current, 255, 255, 38229);
	}
	function HUE_PUB_Light_server_CCB300() {

		PUB_changeLight(light_current, 255, 255, 34106);
	}
	function HUE_PUB_Light_server_FF0080() {

		PUB_changeLight(light_current, 255, 255, 49173);
	}
	function HUE_PUB_Light_server_81FEC2() {

		PUB_changeLight(light_current, 255, 255, 16165);
	}
	function HUE_PUB_Light_server_00A600() {

		PUB_changeLight(light_current, 255, 255, 21845);
	}
	function HUE_PUB_Light_server_8000FF() {

		PUB_changeLight(light_current, 255, 255, 60052);
	}
	function HUE_PUB_Light_server_FF80FF() {

		PUB_changeLight(light_current, 255, 255, 54613);
	}

	function HUE_PUB_Light_server_0080FF() {
		PUB_changeLight(light_current, 255, 255, 5483);
	}

	function HUE_PUB_Light_server_00FFFF() {

		PUB_changeLight(light_current, 255, 255, 10922);
	}

	function HUE_PUB_Light_server_0000FF() {

		PUB_changeLight(light_current, 255, 255, 0);
	}
	function HUE_PUB_Light_server_404080() {

		PUB_changeLight(light_current, 255, 255, 4529);
	}

	function HUE_PUB_Light_server_ABC400() {

		PUB_changeLight(light_current, 255, 255, 31374);
	}
	function HUE_PUB_Light_server_808000() {

		PUB_changeLight(light_current, 255, 255, 32768);
	}
	function HUE_PUB_Light_server_400080() {

		PUB_changeLight(light_current, 255, 255, 60074);
	}

	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonCCB300"), HUE_PUB_Light_buttonCCB300 = function () {
		HUE_PUB_Light_server_CCB300();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonFF8000"), HUE_PUB_Light_buttonFF8000 = function () {
		HUE_PUB_Light_server_FF8000();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button804000"), HUE_PUB_Light_button804000 = function () {
		HUE_PUB_Light_server_804000();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonABC400"), HUE_PUB_Light_buttonABC400 = function () {
		HUE_PUB_Light_server_ABC400();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button808000"), HUE_PUB_Light_button808000 = function () {
		HUE_PUB_Light_server_808000();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonFF0080"), HUE_PUB_Light_buttonFF0080 = function () {
		HUE_PUB_Light_server_FF0080();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button00A600"), HUE_PUB_Light_button00A600 = function () {
		HUE_PUB_Light_server_00A600();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button81FEC2"), HUE_PUB_Light_button81FEC2 = function () {
		HUE_PUB_Light_server_81FEC2();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button400080"), HUE_PUB_Light_button400080 = function () {
		HUE_PUB_Light_server_400080();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button00FFFF"), HUE_PUB_Light_button00FFFF = function () {
		HUE_PUB_Light_server_00FFFF();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button8000FF"), HUE_PUB_Light_button8000FF = function () {
		HUE_PUB_Light_server_8000FF();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("buttonFF80FF"), HUE_PUB_Light_buttonFF80FF = function () {
		HUE_PUB_Light_server_FF80FF();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button0080FF"), HUE_PUB_Light_button0080FF = function () {
		HUE_PUB_Light_server_0080FF();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button0000FF"), HUE_PUB_Light_button0000FF = function () {
		HUE_PUB_Light_server_0000FF();
	});
	IR.AddListener(IR.EVENT_ITEM_PRESS, HUE_GUI.page.GetItem("button404080"), HUE_PUB_Light_button404080 = function () {
		HUE_PUB_Light_server_404080();
	});

	IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE_GUI.cloud, function () {
		foretest = HUE_GUI.local_cloud.Value;
	});
}
 */